Revision 05b4ebd2c7cbb3671c376754b37b4963dd08a3a2 authored by Linus Torvalds on 23 October 2022, 22:00:43 UTC, committed by Linus Torvalds on 23 October 2022, 22:00:43 UTC
Pull kvm fixes from Paolo Bonzini:
 "RISC-V:

   - Fix compilation without RISCV_ISA_ZICBOM

   - Fix kvm_riscv_vcpu_timer_pending() for Sstc

  ARM:

   - Fix a bug preventing restoring an ITS containing mappings for very
     large and very sparse device topology

   - Work around a relocation handling error when compiling the nVHE
     object with profile optimisation

   - Fix for stage-2 invalidation holding the VM MMU lock for too long
     by limiting the walk to the largest block mapping size

   - Enable stack protection and branch profiling for VHE

   - Two selftest fixes

  x86:

   - add compat implementation for KVM_X86_SET_MSR_FILTER ioctl

  selftests:

   - synchronize includes between include/uapi and tools/include/uapi"

* tag 'for-linus' of git://git.kernel.org/pub/scm/virt/kvm/kvm:
  tools: include: sync include/api/linux/kvm.h
  KVM: x86: Add compat handler for KVM_X86_SET_MSR_FILTER
  KVM: x86: Copy filter arg outside kvm_vm_ioctl_set_msr_filter()
  kvm: Add support for arch compat vm ioctls
  RISC-V: KVM: Fix kvm_riscv_vcpu_timer_pending() for Sstc
  RISC-V: Fix compilation without RISCV_ISA_ZICBOM
  KVM: arm64: vgic: Fix exit condition in scan_its_table()
  KVM: arm64: nvhe: Fix build with profile optimization
  KVM: selftests: Fix number of pages for memory slot in memslot_modification_stress_test
  KVM: arm64: selftests: Fix multiple versions of GIC creation
  KVM: arm64: Enable stack protection and branch profiling for VHE
  KVM: arm64: Limit stage2_apply_range() batch size to largest block
  KVM: arm64: Work out supported block level at compile time
2 parent s ca4582c + 9aec606
Raw File
test_fortify.sh
#!/bin/sh
# SPDX-License-Identifier: GPL-2.0-only
set -e

# Argument 1: Source file to build.
IN="$1"
shift
# Extract just the filename for error messages below.
FILE="${IN##*/}"
# Extract the function name for error messages below.
FUNC="${FILE#*-}"
FUNC="${FUNC%%-*}"
FUNC="${FUNC%%.*}"
# Extract the symbol to test for in build/symbol test below.
WANT="__${FILE%%-*}"

# Argument 2: Where to write the build log.
OUT="$1"
shift
TMP="${OUT}.tmp"

# Argument 3: Path to "nm" tool.
NM="$1"
shift

# Remaining arguments are: $(CC) $(c_flags)

# Clean up temporary file at exit.
__cleanup() {
	rm -f "$TMP"
}
trap __cleanup EXIT

# Function names in warnings are wrapped in backticks under UTF-8 locales.
# Run the commands with LANG=C so that grep output will not change.
export LANG=C

status=
# Attempt to build a source that is expected to fail with a specific warning.
if "$@" -Werror -c "$IN" -o "$OUT".o 2> "$TMP" ; then
	# If the build succeeds, either the test has failed or the
	# warning may only happen at link time (Clang). In that case,
	# make sure the expected symbol is unresolved in the symbol list.
	# If so, FORTIFY is working for this case.
	if ! $NM -A "$OUT".o | grep -m1 "\bU ${WANT}$" >>"$TMP" ; then
		status="warning: unsafe ${FUNC}() usage lacked '$WANT' symbol in $IN"
	fi
else
	# If the build failed, check for the warning in the stderr.
	# GCC:
	# ./include/linux/fortify-string.h:316:25: error: call to '__write_overflow_field' declared with attribute warning: detected write beyond size of field (1st parameter); maybe use struct_group()? [-Werror=attribute-warning]
	# Clang 14:
	# ./include/linux/fortify-string.h:316:4: error: call to __write_overflow_field declared with 'warning' attribute: detected write beyond size of field (1st parameter); maybe use struct_group()? [-Werror,-Wattribute-warning]
	if ! grep -Eq -m1 "error: call to .?\b${WANT}\b.?" "$TMP" ; then
		status="warning: unsafe ${FUNC}() usage lacked '$WANT' warning in $IN"
	fi
fi

if [ -n "$status" ]; then
	# Report on failure results, including compilation warnings.
	echo "$status" | tee "$OUT" >&2
else
	# Report on good results, and save any compilation output to log.
	echo "ok: unsafe ${FUNC}() usage correctly detected with '$WANT' in $IN" >"$OUT"
fi
cat "$TMP" >>"$OUT"
back to top